<template>
  <v-chip
    class="[&_.v-chip__content]:truncate"
    size="x-large"
    link
    pill
  >
    <v-avatar start>
      <v-icon
        icon="mdi-account-circle"
        class="text-3xl text-white"
      />
    </v-avatar>

    <span>
      {{ auth.getLogin() }}
    </span>

    <v-menu
      v-model="isMenuShown"
      location="top center"
      transition="scale-transition"
      activator="parent"
    >
      <v-card class="mb-2 min-w-[120%]">
        <v-list class="bg-gradient-to-r from-teal-500 to-cyan-600 text-white">
          <v-list-item>
            <template #prepend>
              <span class="pr-2">
                <v-icon
                  icon="mdi-account-circle"
                  class="text-white text-4xl"
                />
              </span>
            </template>

            <v-list-item-title>
              {{ auth.currentUser.value?.login }}
            </v-list-item-title>

            <v-list-item-subtitle>
              Авторизован
            </v-list-item-subtitle>

            <template #append>
              <v-list-item-action>
                <v-btn
                  variant="text"
                  icon="mdi-close-circle"
                  @click="isMenuShown = false"
                />
              </v-list-item-action>
            </template>
          </v-list-item>
        </v-list>

        <v-list>
          <v-list-item
            link
            @click="isConfirmShown = true"
          >
            <template #prepend>
              <span class="pr-5">
                <v-icon icon="mdi-logout" />
              </span>
            </template>

            <v-list-item-subtitle>
              <span class="font-bold">Выйти</span>
            </v-list-item-subtitle>
          </v-list-item>
        </v-list>
      </v-card>
    </v-menu>
  </v-chip>

  <ConfirmationDialog
    v-model="isConfirmShown"
    :is-loading="isLoading"
    confirm-btn-icon="mdi-logout"
    confirm-btn-label="Выйти"
    @confirm="onConfirmClick"
  >
    Вы действительно хотите выйти из аккаунта?
  </ConfirmationDialog>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useRouter } from 'vue-router';

import { useAuth } from '@/composables';
import { sleep } from '@/utils';

import ConfirmationDialog from '@/components/layout/ConfirmationDialog.vue';

const auth = useAuth();
const router = useRouter();

const isLoading = ref(false);
const isConfirmShown = ref(false);
const isMenuShown = ref(false);

const onConfirmClick = async () => {
  // Just for better user experience
  isLoading.value = true;
  await sleep(200);

  isLoading.value = false;
  isConfirmShown.value = false;

  auth.logout();
  router.push('/login');
};
</script>